package com.example.ellegadodepintia

import android.content.Intent
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.widget.Button
import android.widget.TextView
import androidx.appcompat.app.AlertDialog
import androidx.appcompat.app.AppCompatActivity
import com.example.ellegadodepintia.repositorios.RepositorioJugador
import com.google.firebase.auth.FirebaseAuth

class AuthActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_register)


        val botonRegistrarse = findViewById<Button>(R.id.buttonRegister)
        val textoEmail = findViewById<TextView>(R.id.editTextEmail).text
        val textoPassword = findViewById<TextView>(R.id.editTextPassword).text
        val textoUsername = findViewById<TextView>(R.id.editTextUsername).text

        botonRegistrarse.setOnClickListener {
            if (textoEmail.isNotEmpty() && textoPassword.isNotEmpty() && textoUsername.isNotEmpty()) {
                FirebaseAuth.getInstance().createUserWithEmailAndPassword(
                    textoEmail.toString(),
                    textoPassword.toString()
                ).addOnCompleteListener {
                    if (it.isSuccessful) {
                        RepositorioJugador.addJugador(textoEmail.toString(),textoUsername.toString())
                        RepositorioJugador.cargarJugador(textoEmail.toString())
                        Handler(Looper.getMainLooper()).postDelayed({
                            mostrarMapActivity()
                        },800)

                    } else {
                        showAlert()
                    }
                }
            }
        }

        val botonIniciarSesion = findViewById<Button>(R.id.buttonLogIn)
        botonIniciarSesion.setOnClickListener {
            if (textoEmail.isNotEmpty() && textoPassword.isNotEmpty()) {
                FirebaseAuth.getInstance().signInWithEmailAndPassword(
                    textoEmail.toString(),
                    textoPassword.toString()
                ).addOnCompleteListener {
                    if (it.isSuccessful) {
                        RepositorioJugador.cargarJugador(textoEmail.toString())
                        Handler(Looper.getMainLooper()).postDelayed({
                            mostrarMapActivity()
                        },800)
                    } else {
                        showAlert()
                    }
                }
            }
        }

    }

    private fun showAlert() {
        val builder = AlertDialog.Builder(this)
        builder.setTitle("Error")
        builder.setMessage("Se ha producido un error en la autenticación")
        builder.setPositiveButton("Aceptar", null)
        val dialog: AlertDialog = builder.create()
        dialog.show()
    }

    private fun mostrarMapActivity() {
        val intent = Intent(this, MapActivity::class.java)
        startActivity(intent)
    }



}
